@use "sass:map";
@use "sass:string";
@use "tokens" as tokens;
@use "assets" as assets;
@use "functions" as functions;



/*  =============================================================
    Generate comonent tokens mixin
============================================================== */

@mixin generate-component-tokens($config, $arguments: null) {

	// mixin arguments and config. 
	// can be overwritten by passing new values in the $args map
	// -------------------------------------------------------------------

	$default-args: (
		'selector': null,
		'name': null,
	);
	$args: null;

	// check if additinal args are passed
	@if($arguments) {
		
		// check if arguments is an old selector instead of arg map
		@if type-of($arguments) != map {
			$arguments: (
				'selector': $arguments,
			);
		}
		$args: map.deep-merge($default-args, $arguments);	
	} @else {
		$args: $default-args;	
	}

	
	// mixin code
	// -------------------------------------------------------------------

	@each $component, $variants in $config {

		// check if overwrite name is set -> if yes, use it
		// otherwise use default component name
		$component-name: $component;

		@if map.get($args, 'name') {
			$component-name: map.get($args, 'name');
		}
		

		@each $variant, $tokens in $variants {

			@if type-of($tokens) == map and $variant == "default" {
				@if map.get($args, 'selector') {
					#{map.get($args, 'selector')} {
						@each $token, $value in $tokens {
							--#{$component-name}-#{$token}: #{$value};
						}
					}
				} @else {
					:host {
						@each $token, $value in $tokens {
							--#{$component-name}-#{$token}: #{$value};
						}
					}
				}
					 
			} @else {
				@if map.get($args, 'selector') {
					#{map.get($args, 'selector')}[data-variant="#{$variant}"] {
						@each $token, $value in $tokens {
							--#{$component-name}-#{$token}: #{$value};
						}
					}
					
				} @else {
					:host([data-variant="#{$variant}"]),
					:host([variant="#{$variant}"]) {
						@each $token, $value in $tokens {
							--#{$component-name}-#{$token}: #{$value};
						}
					}
				}
			}
		}
	}
}



/*  =============================================================
    Breakpoint mixin
============================================================== */

@mixin breakpoint($name, $direction: 'up', $second-breakpoint: null) {

    $mode: 'default';
    $category: 'breakpoint';

    @if map.has-key(tokens.$app-tokens, $mode, $category, $name) {
        $breakpoint-value: map.get(tokens.$app-tokens, $mode, $category, $name);

        @if $direction =='up' {
            @media screen and (min-width: $breakpoint-value) {
                @content;
            }
        }

        @else if $direction =='down' {
            @media screen and (max-width: $breakpoint-value - 0.001) {
                @content;
            }
        }

        @else if $direction =='between' and $second-breakpoint !=null {
            @if map.has-key(tokens.$app-tokens, $mode, $category, $second-breakpoint) {
                $second-value: map.get(tokens.$app-tokens, $mode, $category, $second-breakpoint);

                @media screen and (min-width: $breakpoint-value) and (max-width: $second-value - 0.001) {
                    @content;
                }
            }

            @else {
                @warn "Invalid second breakpoint: #{$second-breakpoint}.";
            }
        }

        @else {
            @warn "Invalid direction: #{$direction}.";
        }
    }

    @else {
        @warn "Invalid breakpoint: #{$name}.";
    }
}






/*  =============================================================
    TYPE mixin
============================================================== */

// generates type css based on the name of the type token
@mixin type($name) {
    $mode: 'default';
    $category: 'type';

    @if map.has-key(tokens.$app-tokens, $mode, $category, $name) {
        @each $key, $value in map.get(tokens.$app-tokens, $mode, $category, $name) {
			#{$key}: functions.app-composit-token($category, $name, $key);
		}
    } @else {
        @warn "No type found with name #{$name}";
    }
}




/*  =============================================================
    Webfont mixin 
============================================================== */

@mixin generate-webfonts() {
	@if assets.$webfonts {
		@each $webfont, $webfont-option in assets.$webfonts {
			@font-face {
				font-family: map.get($webfont-option, font-family);
				font-weight: map.get($webfont-option, font-weight);
				font-style: map.get($webfont-option, font-style);
				font-stretch: map.get($webfont-option, font-stretch);
				font-display: map.get($webfont-option, font-display);
				src: local("#{map.get($webfont-option, font-name)}"), url("#{map.get($webfont-option, src)}#{$webfont}.woff2") format("woff2");
			}
		}
	}
}




/*  =============================================================
    Generate icon
============================================================== */

// Generates an icon element
@mixin generate-icon-element($selector: '.adm-icon') {
	#{$selector} {
		display: inline-block;
		width: 1em;
		height: 1em;
		stroke-width: 0;
		stroke: currentColor;
		fill: currentColor;
		font-size: 1em;
	}
}





/*  =============================================================
    Grid utils mixin
============================================================== */

/* # Generate Grid Utils - Generates all utilitie classes or data-attributes for grid # */
@mixin generate-grid-utils() {

    @if map.has-key(tokens.$app-tokens, 'default', 'grid') and map.has-key(tokens.$app-tokens, 'default', 'grid', 'columns') {

        $token-categorie: 'grid';
        $grid-columns: map.get(tokens.$app-tokens, 'default', 'grid', 'columns');

        
        // generate grid parent
        .#{tokens.$token-identifier}#{$token-categorie} {
            display: grid;
            width: 100%;
            gap: functions.grid('gap');
		    grid-template-columns: repeat(functions.grid('columns'), 1fr);
	    }

        // generate basic column 
        .#{tokens.$token-identifier}#{$token-categorie}-column {
            grid-column-end: span functions.grid('columns');
        }



        // generate data-column classes for each column
        @for $i2 from 1 through $grid-columns {
            // create all col-classes
            .#{tokens.$token-identifier}#{$token-categorie}-column[data-columns~="#{$i2}"] {
                grid-column-end: span $i2;
            }
        }
     

        // if breakpoints are defined, iterate trough them and generate specific classes
        @if map.has-key(tokens.$app-tokens, 'default', 'breakpoint') {
            
            $breakpoints: map.get(tokens.$app-tokens, 'default', 'breakpoint');

            @for $i from 1 through length($breakpoints) {
                $iterator: nth($breakpoints, $i);
                $key: nth($iterator, 1);
                $value: nth($iterator, 2);
    
                @media screen and (min-width: $value) {
                    @for $i2 from 1 through $grid-columns {
                        // create all col-classes
                        .#{tokens.$token-identifier}#{$token-categorie}-column[data-columns*="#{$key}-#{$i2}"] {
                            //width: 100%;
                            grid-column-end: span $i2;
                        }
    
                        // create all start by col-classes for offset support
                        .#{tokens.$token-identifier}#{$token-categorie}-column[data-columns*="#{$key}-start-#{$i2}"] {
                            grid-column-start: $i2;
                        }
                    }
                }
            }

        }
    } @else {
        @warn "Warning: No Grid Columns set in App Tokens! You need to set a columns count inside the grid category.";
    }
}



/*  =============================================================
    Container utils mixin
============================================================== */

/* # Generate container Utils - Generates all utilitie classes or data-attributes for widths # */
@mixin generate-container-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'container' {
                    [data-container] { width: 100% }
                    @each $token, $token-value in $tokens {
                        [data-container="#{$token}"] {
                            max-width: functions.width($token);
                        }
                    }
                }
            }
        }
	}
}



/*  =============================================================
    Space utils mixin
============================================================== */

/* # Generate Space Utils - Generates all utilitie classes or data-attributes for spaces # */
@mixin generate-space-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'space' {
                    @each $token, $token-value in $tokens {
                        [data-space-x="#{$token}"] {
                            margin-left: functions.space($token);
                            margin-right: functions.space($token);
                        }
                        [data-space-y="#{$token}"] {
                            margin-top: functions.space($token);
                            margin-bottom: functions.space($token);
                        }
                        [data-space-top="#{$token}"] {
                            margin-top: functions.space($token);
                        }
                        [data-space-bottom="#{$token}"] {
                            margin-bottom: functions.space($token);
                        }
                        [data-space-left="#{$token}"] {
                            margin-left: functions.space($token);
                        }
                        [data-space-right="#{$token}"] {
                            margin-right: functions.space($token);
                        }
                    }
                }
            }
        }
	}
}


/*  =============================================================
    Size utils
============================================================== */

/* # Generate size Utils - Generates all utilitie classes or data-attributes for sizes # */
@mixin generate-size-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'size' {
                    @each $token, $token-value in $tokens {
                        [data-size="#{$token}"] {
                            width: functions.size($token);
                            height: functions.size($token);
                        }
                    }
                }
            }
        }
	}
}


/*  =============================================================
    Height utils
============================================================== */

/* # Generate height Utils - Generates all utilitie classes or data-attributes for heights # */
@mixin generate-height-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'height' {
                    @each $token, $token-value in $tokens {
                        [data-height="#{$token}"] {
                            height: functions.height($token);
                        }
                    }
                }
            }
        }
	}
}


/*  =============================================================
    Width utils
============================================================== */

/* # Generate Width Utils - Generates all utilitie classes or data-attributes for widths # */
@mixin generate-width-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'width' {
                    @each $token, $token-value in $tokens {
                        [data-width="#{$token}"] {
                            width: functions.width($token);
                        }
                    }
                }
            }
        }
	}
}






/*  =============================================================
    Color utils mixin
============================================================== */

// Generates all utilitie classes or data-attributes for colors
@mixin generate-color-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if color category, then generate classes for every color
                @if $token-categorie == 'color' {
                    @each $token, $token-value in $tokens {
                        [data-color="#{$token}"],
                        .#{tokens.$token-identifier}#{$token-categorie}-#{$token} {
                            background: functions.color($token);
                        }
                        [data-color-text="#{$token}"],
                        .#{tokens.$token-identifier}#{$token-categorie}-#{$token}-text {
                            color: functions.color($token);
                        }
                    }
                }
            }
        }
	}
}




/*  =============================================================
    border utils mixin
============================================================== */

// Generates all utilitie classes or data-attributes for borders
@mixin generate-border-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'border' {
                    @each $token, $token-value in $tokens {
                        [data-border="#{$token}"] {
                            border: functions.border($token);
                        }
                        [data-border-x="#{$token}"] {
                            border-left: functions.border($token);
                            border-right: functions.border($token);
                        }
                        [data-border-y="#{$token}"] {
                            border-top: functions.border($token);
                            border-bottom: functions.border($token);
                        }
                        [data-border-top="#{$token}"] {
                            border-top: functions.border($token);
                        }
                        [data-border-bottom="#{$token}"] {
                            border-bottom: functions.border($token);
                        }
                        [data-border-left="#{$token}"] {
                            border-left: functions.border($token);
                        }
                        [data-border-right="#{$token}"] {
                            border-right: functions.border($token);
                        }
                    }
                }
            }
        }
	}
}





/*  =============================================================
    radius utils mixin
============================================================== */

/* # Generate Width Utils - Generates all utilitie classes or data-attributes for widths # */
@mixin generate-radius-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'radius' {
                    @each $token, $token-value in $tokens {
                        [data-radius="#{$token}"] {
                            border-radius: functions.width($token);
                        }
                    }
                }
            }
        }
	}
}



/*  =============================================================
    shadow utils mixin
============================================================== */

/* # Generate shadow Utils - Generates all utilitie classes or data-attributes for shadow # */
@mixin generate-shadow-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'shadow' {
                    @each $token, $token-value in $tokens {
                        [data-shadow="#{$token}"] {
                            box-shadow: functions.shadow($token);
                        }
                    }
                }
            }
        }
	}
}





/*  =============================================================
    elevation utils mixin
============================================================== */

/* # Generate shadow Utils - Generates all utilitie classes or data-attributes for shadow # */
@mixin generate-elevation-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'elevation' {
                    @each $token, $token-value in $tokens {
                        [data-elevation="#{$token}"] {
                            z-index: functions.elevation($token);
                        }
                    }
                }
            }
        }
	}
}




/*  =============================================================
    transition utils mixin
============================================================== */

/* # Generate transition Utils - Generates all utilitie classes or data-attributes for transition # */
@mixin generate-transition-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if space category, then generate classes for every space
                @if $token-categorie == 'transition' {
                    @each $token, $token-value in $tokens {
                        [data-transition="#{$token}"] {
                            transition: functions.transition($token);
                        }
                    }
                }
            }
        }
	}
}



/*  =============================================================
    Type utils
============================================================== */

// Generates all utilitie classes or data-attributes for types
@mixin generate-type-utils() {
    @each $mode, $token-categories in tokens.$app-tokens {
        // check for default mode
        @if type-of($token-categories) == map and $mode == "default" {
            // get all categories
            @each $token-categorie, $tokens in $token-categories {
                // if type category, then generate type classes for all types
                @if $token-categorie == 'type' {

                    @each $token, $token-value in $tokens {
                        // check if token is composit token, if yes, write a var for every subtoken
                        @if type-of($token-value) == map {
                            
                            @if $token == 'h1' or $token == 'h2' or $token == 'h3' or $token == 'h4' or $token == 'h5' or $token == 'h6' {
                                #{$token},
                                .#{tokens.$token-identifier}#{$token-categorie}-#{$token},
                                [data-type="#{$token}"] {
                                    @each $token-part, $token-part-value in $token-value {
                                        #{$token-part}: functions.app-composit-token($token-categorie, $token, $token-part);
                                    }
                                }
                            } @else {
                                .#{tokens.$token-identifier}#{$token-categorie}-#{$token},
                                [data-type="#{$token}"] {
                                    @each $token-part, $token-part-value in $token-value {
                                        #{$token-part}: functions.app-composit-token($token-categorie, $token, $token-part);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
	}
}



